/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_openstack/openstack/v1beta1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// OpenStackMachineTemplateLister helps list OpenStackMachineTemplates.
// All objects returned here must be treated as read-only.
type OpenStackMachineTemplateLister interface {
	// List lists all OpenStackMachineTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.OpenStackMachineTemplate, err error)
	// OpenStackMachineTemplates returns an object that can list and get OpenStackMachineTemplates.
	OpenStackMachineTemplates(namespace string) OpenStackMachineTemplateNamespaceLister
	OpenStackMachineTemplateListerExpansion
}

// openStackMachineTemplateLister implements the OpenStackMachineTemplateLister interface.
type openStackMachineTemplateLister struct {
	indexer cache.Indexer
}

// NewOpenStackMachineTemplateLister returns a new OpenStackMachineTemplateLister.
func NewOpenStackMachineTemplateLister(indexer cache.Indexer) OpenStackMachineTemplateLister {
	return &openStackMachineTemplateLister{indexer: indexer}
}

// List lists all OpenStackMachineTemplates in the indexer.
func (s *openStackMachineTemplateLister) List(selector labels.Selector) (ret []*v1beta1.OpenStackMachineTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.OpenStackMachineTemplate))
	})
	return ret, err
}

// OpenStackMachineTemplates returns an object that can list and get OpenStackMachineTemplates.
func (s *openStackMachineTemplateLister) OpenStackMachineTemplates(namespace string) OpenStackMachineTemplateNamespaceLister {
	return openStackMachineTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// OpenStackMachineTemplateNamespaceLister helps list and get OpenStackMachineTemplates.
// All objects returned here must be treated as read-only.
type OpenStackMachineTemplateNamespaceLister interface {
	// List lists all OpenStackMachineTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.OpenStackMachineTemplate, err error)
	// Get retrieves the OpenStackMachineTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.OpenStackMachineTemplate, error)
	OpenStackMachineTemplateNamespaceListerExpansion
}

// openStackMachineTemplateNamespaceLister implements the OpenStackMachineTemplateNamespaceLister
// interface.
type openStackMachineTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all OpenStackMachineTemplates in the indexer for a given namespace.
func (s openStackMachineTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.OpenStackMachineTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.OpenStackMachineTemplate))
	})
	return ret, err
}

// Get retrieves the OpenStackMachineTemplate from the indexer for a given namespace and name.
func (s openStackMachineTemplateNamespaceLister) Get(name string) (*v1beta1.OpenStackMachineTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("openstackmachinetemplate"), name)
	}
	return obj.(*v1beta1.OpenStackMachineTemplate), nil
}
